﻿UseJPEGImageDecoder()
UsePNGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageEncoder()

Global siz.l=10
Global fs.s=""
Global imode.l=0
Global v$="pixelate 0.9a"

Enumeration
  #menu_open
  #menu_save
  #menu_quit
  #menu_pix_all
  #menu_pix_area
  #menu_gray_all
  #menu_gray_area
EndEnumeration

Enumeration
  #mode_pix
  #mode_gray
EndEnumeration

Procedure loadpic (f.s)
  If LoadImage(0,f)
    w.l=ImageWidth(0)
    h.l=ImageHeight(0)
    GetWindowRect_(GetDesktopWindow_(),@r.RECT)
    If (r\right-r\left<w) Or (r\bottom-r\top<h)
      MessageRequester("error", "Can't fit to desktop", #PB_MessageRequester_Ok)
      fs=""
    EndIf
    ;resize
    ResizeWindow(0, (r\right-r\left-w)/2, (r\bottom-r\top-h)/2, w,h) 
    ResizeGadget(0, 0, 0, w, h)
    fs=f
  Else
    MessageRequester("error", "can't read "+f, #PB_MessageRequester_Ok)
    fs=""
  EndIf
EndProcedure

Procedure.w MouseWheelDelta()
  x.w = ((EventwParam()>>16)&$FFFF)
  ProcedureReturn -(x / 120)
EndProcedure

Procedure redrawpic()
  StartDrawing(CanvasOutput(0))
  DrawImage(ImageID(0),0,0)
  StopDrawing()
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, v$, #PB_Window_MinimizeGadget|#PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 0, 0, 640, 480)
  If CountProgramParameters()
    loadpic(ProgramParameter(0))
    redrawpic()
  EndIf
  EnableGadgetDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#menu_open, "Open..."   +Chr(9)+"Ctrl+O")
    MenuItem(#menu_save, "Save"   +Chr(9)+"Ctrl+S")
    MenuBar()
    MenuItem(#menu_quit, "Quit"  +Chr(9)+"Ctrl+Q")
    
    MenuTitle("Image")
    
    OpenSubMenu("Gray")
    MenuItem( #menu_gray_all, "All")
    MenuItem( #menu_gray_area, "Area")
    CloseSubMenu()
    
    OpenSubMenu("Pidxelate")
    MenuItem( #menu_pix_all, "All")
    MenuItem( #menu_pix_area, "Area")
    CloseSubMenu()
    
    SetMenuItemState(0,#menu_pix_area,1)
    
    AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_Q ,#menu_quit)
    AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_O ,#menu_open)
    AddKeyboardShortcut(0,#PB_Shortcut_Control|#PB_Shortcut_S ,#menu_save)
  EndIf
  
  
  Repeat
    Event = WaitWindowEvent()
        If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      Break
    EndIf

    Select event
      Case #PB_Event_GadgetDrop
        t$ = EventDropFiles()
        t$ = StringField(t$, 1, Chr(10))
        loadpic(t$)
        redrawpic()
        
      Case #WM_MOUSEWHEEL
        dd.l=MouseWheelDelta()
        If siz+dd>=2 And siz+dd<=15
          siz+dd
          StartDrawing(CanvasOutput(0))
          DrawImage(ImageID(0),0,0)
          DrawingMode(#PB_2DDrawing_XOr|#PB_2DDrawing_Outlined)
          Box(x,y,siz*10,siz*10,$FFFFFF)
          StopDrawing()
          SetWindowTitle( 0,v$+",s:"+Str(siz) )
        EndIf
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_pix_area
            imode=#mode_pix
            SetMenuItemState(0,#menu_pix_area,1)
            SetMenuItemState(0,#menu_gray_area,0)
          Case #menu_gray_area
            imode=#mode_gray
            SetMenuItemState(0,#menu_pix_area,0)
            SetMenuItemState(0,#menu_gray_area,1)

          Case #menu_gray_all
            w = ImageWidth(0)
            h = ImageHeight(0)
            StartDrawing(ImageOutput(0))
            For x = 0 To w - 1
              For y = 0 To h - 1
                color = Point(x, y)
                r    = Red(color)
                g    = Green(color)
                b    = Blue(color)
                gray = 0.2126*r + 0.7152*g + 0.0722*b
                Plot(x, y, RGB(gray, gray, gray))
              Next
            Next
            StopDrawing()
            redrawpic()
            
          Case #menu_pix_all
            ImgW = ImageWidth(0)
            ImgH = ImageHeight(0)
            
            If ResizeImage(0, ImgW / siz , ImgH / siz)
              If ResizeImage(0,ImgW,ImgH,#PB_Image_Raw) ;<-- #PB_Image_Raw works best
              EndIf
            EndIf
            redrawpic()
            
          Case #menu_open
  ;StandardFile$ = "C:\autoexec.bat"   ; set initial file+path to display
  ; With next string we will set the search patterns ("|" as separator) for file displaying:
  ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
  ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
  ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
  Pattern$ = "Image files|*.bmp;*.jpg;*.png"
  ;Pattern = 0    ; use the first of the three possible patterns as standard
  ;File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
  File$ = OpenFileRequester("Please choose file to load", GetCurrentDirectory(), Pattern$, 0)
  If File$
    loadpic(File$)
    redrawpic()
  EndIf

            

          Case #menu_save
            If fs<>""
              e.s=LCase( GetExtensionPart(fs) )
              If e="jpg"
                SaveImage(0,fs,#PB_ImagePlugin_JPEG)
              ElseIf e="png"
                SaveImage(0,fs,#PB_ImagePlugin_PNG)
              Else
                SaveImage(0,fs)
              EndIf
            EndIf
          Case #menu_quit:Break
        EndSelect
        
        
      Case #PB_Event_Gadget
        If EventGadget() = 0 ;    If Event = #PB_Event_Gadget And EventGadget() = 0 
                             ;        If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
          If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove); And GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
                                                                                                  ;If StartDrawing(CanvasOutput(0))
            x = siz*Int( GetGadgetAttribute(0, #PB_Canvas_MouseX)/siz)
            y = siz*Int( GetGadgetAttribute(0, #PB_Canvas_MouseY)/siz)
            ;Circle(x, y, 10, RGB(Random(255), Random(255), Random(255)))
            ;StopDrawing()
            ;EndIf
            If GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton    
              If x>=0 And y>=0
                
                If imode=#mode_pix
                  GrabImage(0,1,x,y,siz*10,siz*10)
                  ResizeImage(1,siz,siz,#PB_Image_Smooth)
                  ResizeImage(1,siz*10,siz*10,#PB_Image_Raw)
                  
                  StartDrawing(ImageOutput(0))
                  DrawImage(ImageID(1),x,y)
                  StopDrawing()
                ElseIf imode=#mode_gray
                  w = ImageWidth(0)
                  h = ImageHeight(0)
                  StartDrawing(ImageOutput(0))
                  For xx = 0 To siz*10-1
                    For yy = 0 To siz*10 - 1
                      If x+xx<w And y+yy<h
                        color = Point(x+xx, y+yy)
                        r    = Red(color)
                        g    = Green(color)
                        b    = Blue(color)
                        gray = 0.2126*r + 0.7152*g + 0.0722*b
                        Plot(x+xx, y+yy, RGB(gray, gray, gray))
                      EndIf
                    Next yy
                  Next xx
                  StopDrawing()
                EndIf

              EndIf
              
            EndIf
            StartDrawing(CanvasOutput(0))
            DrawImage(ImageID(0),0,0)
            DrawingMode(#PB_2DDrawing_XOr|#PB_2DDrawing_Outlined)
            Box(x,y,siz*10,siz*10,$FFFFFF)
            StopDrawing()
            
          EndIf
        EndIf    
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 95
; FirstLine = 71
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = depix.ico
; Executable = pixelate.exe
; CommandLine = 3ed7738d3b56921063c943a1ea864cc6.jpg